import { J as JIRATickets, a as JIRABoardState, b as JIRABoardConfigArgs, c as JIRAState, d as JIRAHourState, e as JIRAHourConfigArgs } from './types-21c7edff.js';
export { g as JIRABoardConfig, f as JIRABoardSharedConfig, h as JIRATicket } from './types-21c7edff.js';

declare const render: (columns: string[], tickets: JIRATickets) => string;

declare const convertTextToBoardHTML: (state: JIRABoardState) => JIRABoardState<string>;
declare const createJIRABoard: (...args: JIRABoardConfigArgs) => JIRAState;

declare const convertTextToHourHtml: (state: JIRAHourState) => JIRAHourState<string>;
declare const createJIRAHour: (...args: JIRAHourConfigArgs) => JIRAState;

declare const reduce: <T extends unknown, Callback extends (...args: any[]) => string>(target: T[], callback: Callback, interval?: string) => string;
declare const writeClipboard: (text?: string) => void;
declare const getElement: (id?: string | Element) => Element;
declare const isS: (s: unknown) => s is string;
declare const isE: (e: unknown) => e is Element;
declare const isSE: (se: unknown) => se is string | Element;
declare const parseConfig: <T extends object, Arg extends T[keyof T] | Partial<T> = T[keyof T] | Partial<T>>(defaultConfig: T, ...args: Arg[]) => any;

export { JIRABoardConfigArgs, JIRABoardState, JIRATickets, convertTextToBoardHTML, convertTextToHourHtml, createJIRABoard, createJIRAHour, createJIRABoard as default, getElement, isE, isS, isSE, parseConfig, reduce, render, writeClipboard };
