interface JIRASharedConfig {
    TITLE: string;
    LABEL: string;
    title: string;
    label: string;
}
interface JIRAConfig extends JIRASharedConfig {
    target?: string | Element;
    button?: string | Element;
    select?: string | Element;
    input?: string | Element;
}
interface JIRAState extends JIRASharedConfig {
    (e?: Event | Element): void;
    update(markdown?: string): void;
    convert<T extends JIRAState>(state: T): void;
    markdown: string;
    results: string[];
    result: string;
    target: Element;
    button: Element;
    select: Element;
    input: Element;
    ref: (el: unknown) => void;
    onMount: (el?: Element) => void;
    onClean: () => void;
    onClick: () => void;
    onSelect: (e: any) => void;
    onChange: (e: any) => void;
}
type JIRAConfigArgs<S extends string | Element = string | Element, T extends Partial<JIRAConfig> = Partial<JIRAConfig>> = [config?: T] | [target?: S, config?: T] | [target?: S, button?: S, config?: T] | [target?: S, button?: S, select?: S, config?: T] | [target?: S, button?: S, select?: S, input?: S, config?: T];

interface JIRABoardSharedConfig$1 extends JIRASharedConfig {
    TICKET: string;
    BACKLOG: string;
    labelReg: string;
}
interface JIRABoardConfig extends JIRAConfig, JIRABoardSharedConfig$1 {
}
interface JIRABoardState<Key extends string = string> extends JIRAState, JIRABoardSharedConfig$1 {
    tickets: JIRATickets;
    backlog: JIRATicket[];
    columns: Set<Key>;
}
type JIRABoardConfigArgs = JIRAConfigArgs<string | Element, Partial<JIRABoardConfig>>;
interface JIRATicket {
    task?: string;
    label?: string;
    order?: number;
    column?: string;
    detail?: string;
    disable?: boolean;
}
type JIRATickets<Key extends string = string> = Map<Key, JIRATicket[]>;

interface JIRABoardSharedConfig extends JIRASharedConfig {
    DATE: string;
    HOUR: string;
    dateReg: string;
    hourReg: string;
    labelReg: string;
}
interface JIRAHourConfig extends JIRAConfig, JIRABoardSharedConfig {
}
interface JIRAHourState<Key extends string = string> extends JIRAState, JIRABoardSharedConfig {
    hours: JIRAHours;
    columns: Set<Key>;
    rest: number;
    total: number;
    duration: number;
}
type JIRAHourConfigArgs = JIRAConfigArgs<string | Element, Partial<JIRAHourConfig>>;
interface JIRAHour {
    from?: string;
    to?: string;
    task?: string;
    label?: string;
    detail?: string;
    disable?: boolean;
    duration?: number;
}
type JIRADateHour = JIRAHour[] & {
    first?: JIRAHour;
    last?: JIRAHour;
    size?: number;
    rest?: number;
    total?: number;
    duration?: number;
};
type JIRAHours<Key extends string = string> = Map<Key, JIRADateHour>;

export { JIRATickets as J, JIRABoardState as a, JIRABoardConfigArgs as b, JIRAState as c, JIRAHourState as d, JIRAHourConfigArgs as e, JIRABoardSharedConfig$1 as f, JIRABoardConfig as g, JIRATicket as h };
